// -*- mode: c++; -*-
#include <kmainwindow.h>

class MemController;
class MemPanel;
class MemTheme;

class MainWindow : public KMainWindow {
  Q_OBJECT

public:
  MainWindow(const char* name=0);

public slots:
  void newGame();
  void setSinglePlayer();
  void setTwoPlayers();
  void setSmallGame();
  void setLargeGame();
  void setHugeGame();
  void setMatch2();
  void setMatch3();
  void setMatch4();
  void setThemeDefault();
  void setThemeSlashdot();

private:
  void settingsChanged();
  void readConfig();
  void writeConfig();

private:
  QDockWindow* m_dock_window;
  MemPanel* m_mem_panel;
  MemController* m_mem_controller;
  MemTheme* m_theme;

  QString m_theme_name;
  bool m_is_single_player;
  int m_game_size;
  int m_n_match;
};

