// -*- mode: c++; -*-
#include <qcanvas.h>
#include <vector>

class MemTheme;
class QMouseEvent;
class MemPanel : public QCanvasView {
  Q_OBJECT
public:
  MemPanel(QWidget* parent, MemTheme* theme,
	   int num_cols, int num_rows, int num_match);
  ~MemPanel();

  void init();

  void contentsMousePressEvent(QMouseEvent* e);
  void contentsMouseReleaseEvent(QMouseEvent* e);
  int findCard(QMouseEvent* e);
  
  signals:
  void move();
  void miss();
  void guess(bool firstSeen);
  void gameOver();
  
private:
  class CardInfo;
  std::vector<CardInfo*> m_cards;
  std::vector<int> m_selected_cards;
  int m_num_rows, m_num_cols;
  int m_num_match;

  MemTheme* m_theme;
};

